<?php 
/* Оплата с лицевого счета */
class system_of_pay_handler
{
	/**
	 * Обработка статуса оплаты
	 *
	 */
	function ProcessResult()
	{

	}

	/**
	 * Отображает стартовую страницу для оплаты с лицевого счета.
	 *
	 */
	function ShowPurseRequest()
	{
		$shop_id = to_int($GLOBALS['shop_id']);

		?>
		<h1>Оплата с лицевого счета пользователя</h1>
		<?php 

		/* Получаем id текущего пользователя сайта */
		if (class_exists('SiteUsers'))
		{
			/* Получаем id текущего пользователя сайта */
			$SiteUsers = & singleton('SiteUsers');
			$site_users_id = $SiteUsers->GetCurrentSiteUser();
		}
		else
		{
			?>
			<p>Вы не авторизированы. Для продолжения оплаты необходимо авторизироваться на сайте.</p>
			<?php 
			return false;
		}

		// ID платежной системы берем из сессии
		$system_of_pay_id = to_int($_SESSION['system_of_pay_id']);

		// статус платежа, по умолчанию 0
		$order_row['status_of_pay'] = 0 ;

		// дата платежа, по умолчанию пустая строка
		$order_row['date_of_pay'] = '';

		// описание и системная информация, по умолчанию пустая строка
		if (to_str($_SESSION['shop_coupon_text']) != '')
		{
			$order_row['description'] = "Купон на скидку: ".to_str($_SESSION['shop_coupon_text'])."\n";
		}
		else
		{
			$order_row['description'] = '';
		}

		$shop = & singleton('shop');

		// Оформляем заказ
		$order_id = $shop->ProcessOrder($shop_id, $site_users_id, $system_of_pay_id, $order_row);

		if ($order_id > 0)
		{
			$user_email = false;

			if ($order_row)
			{
				$shop_row = $shop->GetShop($GLOBALS['shop_id']);

				// Проводим транзакцию
				$this->AccountTransaction($site_users_id, $GLOBALS['shop_id'], $order_row['sum'], $shop_row['shop_currency_id'], $order_id);
			}

			/* Формируем XML */
			$xmlData = '<?xml version="1.0" encoding="'.SITE_CODING.'"?>'."\n";
			$xmlData .= '<document_list>'."\n";

			/* Ссылака на версию для печати */
			$shop_row = $shop->GetShop($shop_id);
			if ($shop_row)
			{
				/* Получаем путь к магазину */
				$Structure = & singleton('Structure');
				$shop_path = "/".$Structure->GetStructurePath($shop_row['structure_id'], 0);
				$shop_path .= "cart/print/$order_id/";
				$xmlData .= "<print_link>".$shop_path."</print_link>";
			}

			$xmlData .= $shop->GetXmlForOrder($order_id, false, true);
			$xmlData .= $shop->GetXmlForItemsOrder($order_id);
			$xmlData .= '</document_list>'."\n";

			$xsl = new xsl();
			echo $xsl->build($xmlData, 'ОплатаПриПолучении');

			/* Отправляем письмо заказчику */
			$shop->SendMailAboutOrder($shop_id, $order_id, $site_users_id,
			$GLOBALS['LA']['xsl_letter_to_admin'], $GLOBALS['LA']['xsl_letter_to_user'], $user_email,
			array('admin-content-type' => 'html', 'user-content-type' => 'html'));
		}
		else
		{
			switch ($order_id)
			{
				case -1:
					{
						?>
						<p>Ошибка вставки заказа в базу данных. Обратитесь к администратору.</p>
						<?php 
						break;
					}
				case -2:
					{
						?>
						<p>Не найден магазин. Обратитесь к администратору.</p>
						<?php 
						break;
					}
				case -3:
					{
						?>
						<p>Корзина пуста, оформление заказа невозможно.</p>
						<?php 
						break;
					}
			}
		}
	}

	/**
	 * Проведение транзакции лицевого счета пользователя сайта
	 *
	 * @param int $site_users_id идентификатор пользователя сайта
	 * @param int $shop_id идентификатор магазина
	 * @param float $order_row_sum сумма заказа
	 * @param int $shop_currency_id идентификатор валюты
	 * @param int $order_id идентификатор заказа
	 */
	function AccountTransaction($site_users_id, $shop_id, $order_row_sum, $shop_currency_id, $order_id)
	{
		$DataBase = & singleton('DataBase');

		$shop = & singleton('shop');

		// Определяем сумму на балансе клиента
		$DataBase->query('LOCK TABLES shop_site_users_account_table WRITE,
				shop_order_table WRITE,
				shop_shops_table WRITE');

		$site_users_account_sum = $shop->GetSiteUserAccountSum($site_users_id, $shop_id);

		// Если сумма заказа больше 0 и на счете достаточно средств для осуществления транзакции
		if ($order_row_sum > 0 && $site_users_account_sum > $order_row_sum)
		{
			// Сумма отрицательная, т.к. идет списание со счета
			$sum = $order_row_sum * -1;

			// Списываем со счета сумму
			$transaction_id = $shop->InsertSiteUserAccountTransaction(array('shop_shops_id' => $shop_id,
			'site_users_id' => $site_users_id,
			'shop_site_users_account_active' => 1,
			'shop_site_users_account_sum' => $sum,
			'shop_currency_id' => $shop_currency_id,
			'shop_site_users_account_sum_in_base_currency' => $sum,
			'shop_order_id' => $order_id,
			'shop_site_users_account_description' => "Оплата заказа N {$order_id}"));

			// Разблокируем таблицу
			$DataBase->query('UNLOCK TABLES');

			$tmp_order_row = $shop->GetOrder($order_id);

			/* Устанавливаем параметры */
			$param['id'] = $tmp_order_row ['shop_order_id'];
			$param['shop_shops_id'] = $tmp_order_row ['shop_shops_id'];
			$param['location_id'] = $tmp_order_row ['shop_location_id'];
			$param['country_id'] = $tmp_order_row ['shop_country_id'];
			$param['shop_city_id'] = $tmp_order_row ['shop_city_id'];
			$param['city_area_id'] = $tmp_order_row ['shop_city_area_id'];
			$param['shop_cond_of_delivery_id'] = $tmp_order_row ['shop_cond_of_delivery_id'];
			$param['delivery_price'] = $tmp_order_row ['shop_order_delivery_price'];
			$param['site_user_id'] = $tmp_order_row ['site_users_id'];
			$param['shop_order_status_id'] = $tmp_order_row ['shop_order_status_id'];
			$param['currency_id'] = $tmp_order_row ['shop_currency_id'];
			$param['shop_system_of_pay_id'] = $tmp_order_row ['shop_system_of_pay_id'];
			$param['order_date_time'] = $tmp_order_row ['shop_order_date_time'];
			$param['status_of_pay'] = $tmp_order_row ['shop_order_status_of_pay'];
			$param['date_of_pay'] = $tmp_order_row ['shop_order_date_of_pay'];
			$param['address'] = $tmp_order_row ['shop_order_address'];
			$param['index'] = $tmp_order_row ['shop_order_index'];
			$param['phone'] = $tmp_order_row ['shop_order_phone'];
			$param['description'] = $tmp_order_row ['shop_order_description'];

			$currency_row = $shop->GetCurrency($shop_currency_id);

			if ($currency_row)
			{
				$currency_name = $currency_row['shop_currency_international_name'];
			}
			else
			{
				$currency_name = '';
			}

			$param['system_information'] = "Товар оплачен с лицевого счета.\n".
			"Сумма: {$order_row_sum} {$currency_name}\n".
			"Номер транзакции: {$transaction_id}";

			/* Устанавливаем признак оплаты */
			$param['date_of_pay'] = date("Y-m-d H:i:s");
			$param['status_of_pay'] = true;

			// Обновляем информацию о заказе
			$shop->InsertOrder($param);

			$shop_row = $shop->GetShop($shop_id);
			
			$structure = & singleton('Structure');
			$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

			$lib = new lib();
			$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

			$date_str = date("d.m.Y H:i:s");

			// Отправляем письмо администратору о подтверждении платежа
			$shop->SendMailAboutOrder($tmp_order_row['shop_shops_id'],
			$order_id,
			$tmp_order_row['site_users_id'],
			to_str($LA['xsl_letter_to_admin']),
			to_str($LA['xsl_letter_to_user']),
			$tmp_order_row['shop_order_users_email'],
			array(
			'admin-content-type' => 'html',
			'user-content-type' => 'html',
			'admin-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_confirm_admin_subject'], $order_id, $shop_row['shop_shops_name'], $date_str),
			'user-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_confirm_user_subject'], $order_id, $shop_row['shop_shops_name'], $date_str)));
			
			?>
			<p>Спасибо, Ваш заказ оформлен. Подробная информация отправлена на Ваш электронный адрес.</p>
			<?php 
		}
		else
		{
			// Разблокируем таблицу
			$DataBase->query('UNLOCK TABLES');

			if ($order_row_sum > 0)
			{
				?>
				<p>На лицевом счете недостаточно средств для проведения операции.</p>
				<?php 
			}
			else
			{
				?>
				<p>Сумма заказа равна 0, продолжение оформления заказа с использованием выбранной платежной системы невозможно.</p>
				<?php 
			}
		}
	}

	/**
	 * Метод, запускающий выполнение обработчика
	 */
	function Execute()
	{
		// оформляем заказ
		$this->ShowPurseRequest();
	}

	/**
	 * Метод для отображения формы заказа для печати.
	 *
	 * @param int $order_id идентификатор заказа
	 */
	function PrintOrder($order_id)
	{
		$shop = & singleton('shop');

		/* Информация о заказе */
		$order_row = $shop->GetOrder($order_id);

		if (!$order_row)
		{
			return false;
		}

		/* Информация о магазине */
		$shop_row = $shop->GetShop($order_row['shop_shops_id']);
		if (!$shop_row)
		{
			return false;
		}

		?>
		<h1>Оплата с лицевого счета пользователя</h1>
		<?php 

		$sum = $shop->GetOrderSum($order_id);

		// Оплатить и заказ при этом еще не оплачен
		if (isset($_POST['Pay']) && $order_row['shop_order_status_of_pay'] == 0)
		{
			/* Получаем id текущего пользователя сайта */
			$SiteUsers = & singleton('SiteUsers');
			$site_users_id = $SiteUsers->GetCurrentSiteUser();

			$this->AccountTransaction($site_users_id, $order_row['shop_shops_id'], $sum, $order_row['shop_currency_id'], $order_id);
		}
		else
		{
			$DateClass = new DateClass();

			// Заказ не оплачен
			if ($order_row['shop_order_status_of_pay'] == 0)
			{
				$currency_row = $shop->GetCurrency($order_row['shop_currency_id']);

				if ($currency_row)
				{
					$currency_name = $currency_row['shop_currency_name'];
				}
				else
				{
					$currency_name = '';
				}

				?>
				<p>Сумма к оплате с лицевого счета составляет <?php echo $sum?> <?php echo $currency_name?></p>
				<p>
				<form action="./" method="post">
					<input type="submit" name="Pay" value="Оплатить <?php echo $sum?> <?php echo $currency_name?>" />
				</form>
				</p>
				<?php 
			}
			else // Заказ оплачен
			{
				?>
				<p>Ваш заказ был оплачен <?php echo $DateClass->datetime_format($order_row['shop_order_date_of_pay'])?>.</p>
				<?php 
			}
		}
	}
	
	/**
	 * Изменение статуса заказа. Позволяет пользователю внедрять собственные
	 * обработчики при изменении статуса.
	 * 
	 * @param array $param массив атрибутов
	 * - $param['shop_order_id'] идентификатор заказа
	 * - $param['action'] выполняемое действие над заказом, может принимать
	 * значения: edit (редактирование товара), cancel (отмена заказ),
	 * status (изменение статуса заказа), delete (удаление заказа)
	 */
	function ChangeStatus($param = array())
	{
		
	}
}
?>